﻿Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient

Public Class Form1

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        cbCountries.DataSource = Me.GetData("SELECT CountryId, CountryName FROM Countries")
        cbCountries.DisplayMember = "CountryName"
        cbCountries.ValueMember = "CountryId"
        cbStates.Enabled = False
        cbCities.Enabled = False
    End Sub

    Private Sub cbCountries_SelectionChangeCommitted(ByVal sender As Object, ByVal e As EventArgs) Handles cbCountries.SelectionChangeCommitted
        cbStates.DataSource = Nothing
        cbCities.DataSource = Nothing
        cbStates.Enabled = False
        cbCities.Enabled = False
        If cbCountries.SelectedValue.ToString() <> "0" Then
            Dim sql As String = String.Format("SELECT StateId, StateName FROM States WHERE CountryId = {0}", cbCountries.SelectedValue)
            cbStates.DataSource = Me.GetData(sql)
            cbStates.DisplayMember = "StateName"
            cbStates.ValueMember = "StateId"
            cbStates.Enabled = True
        End If
    End Sub

    Private Sub cbStates_SelectionChangeCommitted(ByVal sender As Object, ByVal e As EventArgs) Handles cbStates.SelectionChangeCommitted
        cbCities.DataSource = Nothing
        cbCities.Enabled = False
        If cbStates.SelectedValue.ToString() <> "0" Then
            Dim sql As String = String.Format("SELECT CityId, CityName FROM Cities WHERE StateId = {0}", cbStates.SelectedValue)
            cbCities.DataSource = Me.GetData(sql)
            cbCities.DisplayMember = "CityName"
            cbCities.ValueMember = "CityId"
            cbCities.Enabled = True
        End If
    End Sub

    Private Sub btnSubmit_Click(ByVal sender As Object, ByVal e As EventArgs) Handles btnSubmit.Click
        Dim message As String = "Country: " & cbCountries.Text
        message &= Environment.NewLine
        message &= "State: " & cbStates.Text
        message &= Environment.NewLine
        message &= "City: " & cbCities.Text
        MessageBox.Show(message)
    End Sub

    Private Function GetData(ByVal sql As String) As DataTable
        Dim constr As String = "Data Source=.\SQL2014;Initial Catalog=Cascading_ddl;Integrated Security=true"
        Using con As SqlConnection = New SqlConnection(constr)
            Using sda As SqlDataAdapter = New SqlDataAdapter(sql, con)
                Dim dt As DataTable = New DataTable()
                sda.Fill(dt)
                Dim row As DataRow = dt.NewRow()
                row(0) = 0
                row(1) = "Please select"
                dt.Rows.InsertAt(row, 0)
                Return dt
            End Using
        End Using
    End Function
End Class
